package jp.cox.swf.util;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

/**
 * SWFێNXB<br />
 * vꂽNGXgɑ΂āAێĂswfĕԂ܂<br />
 * ێĂȂꍇɂ́Aw肳ꂽL[œǂݍSWFێ悤ɂ܂<br />
 * Iɂ́AێoCiSẴTCYȏ
 * 傫𒴂AgpȂ̂jĕێȂ悤ɂB<br />
 * 
 * @author Shunichi Todoroki
 */
public class SwfHolder {
	//SwfoCiێ}bv
	private static final Map<String, byte[]> 
		binaryMap = new ConcurrentHashMap<String, byte[]>();
	
	/*
	 * CX^XȂB
	 */
	private SwfHolder() {
	}

	/**
	 * swfNGXgT[ubgĂяoƂɂāAێĂswfĕԂ܂B<br />
	 * ێ邽߂̃L[̓T[ubgpXɂȂ܂
	 * 
	 * @param ctx T[ubgReLXg
	 * @param request T[ubgNGXg
	 * @return swfIuWFNg
	 * @throws IOException IOO
	 */
	public static Swf getSwf(ServletContext ctx, HttpServletRequest request)
			throws IOException {
		String requestUri = request.getRequestURI();
		String swfFile = ctx.getRealPath(requestUri);
		if(!swfFile.endsWith(".swf")) {
			swfFile += ".swf";
		}
		File file = new File(swfFile);
		return getSwf(requestUri, file);
	}

	/**
	 * ێĂswfĕԂ܂B<br />
	 * ێ邽߂̃L[̓t@C̐΃pXɂȂ܂
	 * 
	 * @param file t@C
	 * @return swfIuWFNg
	 * @throws IOException IOO
	 */
	public static Swf getSwf(File file) throws IOException {
		return getSwf(file.getAbsolutePath(), file);
	}

	/*
	 * ێĂswfĕԂ܂B<br />
	 * ێĂswfkeyŌĂswfIuWFNgƂĕԂAȂfileǂݍŕԂ܂
	 * 
	 * @param key
	 * @param file
	 * @return
	 * @throws IOException IOO
	 */
	private static Swf getSwf(String key, File file) throws IOException {
		if(key == null || file == null) {
			throw new NullPointerException("key or file is null. key [" + key
					+ ", file [" + file + "]");
		}
		if(!file.exists()) {
			throw new IllegalArgumentException(
					"the file is not exists. file path ["
							+ file.getAbsolutePath() + "]");
		}
		if(binaryMap.containsKey(key)) {
			return new Swf(binaryMap.get(key));
		} else {
			synchronized (SwfHolder.class) {
				if(!binaryMap.containsKey(key)) {
					//\[Xǂݍ
					BufferedInputStream in = null;
					try {
						int available = 0;
						in = new BufferedInputStream(new FileInputStream(file));
						ByteArrayOutputStream out = new ByteArrayOutputStream();
						while((available = in.available()) > 0) {
							byte[] b = new byte[available];
							in.read(b, 0, available);
							out.write(b);
						}
						binaryMap.put(key, out.toByteArray());
					} finally {
						if(in != null) {
							try {
								in.close();
							} catch(Exception e) {}
						}
					}
				}
			}
			return new Swf(binaryMap.get(key));
		}
	}
}
